From 9af6dfc60f2b8fdb4d5a94fc5ee4cf246dac37fa Mon Sep 17 00:00:00 2001
From: Jean-Baptiste Holcroft <jean-baptiste@holcroft.fr>
Date: May 24 2021 17:21:31 +0000
Subject: [PATCH 45/88] replace cp -r by cp -a & run hardlink at the end


as asked in https://pagure.io/fedora-infrastructure/issue/8964

---

diff --git a/build-scripts/rebuild-site.py b/build-scripts/rebuild-site.py
index 10e0537..99734aa 100755
--- a/build-scripts/rebuild-site.py
+++ b/build-scripts/rebuild-site.py
@@ -368,18 +368,48 @@ def main():
                     sys.exit(1)
 
             # Copying all the translated sites
+            log("")
+            log("=== Copying translated sites ===")
+
+            results_dir = os.path.join(docs_repo, "public")
+            publish_dir = "/antora/output"
+            copying_dir = os.path.join(publish_dir, "copying.tmp")
+
+            # I have:
+            # docs_repo/public            <- results_dir  (local partition)
+            # /antora/output/copying.tmp  <- copying_dir  (mounted partition)
+            # /antora/output              <- publish_dir  (mounted partition)
+            #
+            # I need to:
+            #   1/  copy from local to mounted
+            #   2/  remove old in mounted
+            #   3/  move new within mounted
+            #   4/  remove the copying dir
+
+            # Make sure copying_dir exists and is empty
+            shutil.rmtree(copying_dir, ignore_errors=True)
+            subprocess.run(["mkdir", copying_dir])
+
+            # Copy results from local partition to a mounted partition
+            log("Copying between partitions...")
+            subprocess.run(["cp", "-a", results_dir, "{}/".format(copying_dir)])
+
+            # Swap the old tree for the new one for each language
+            log("Moving languages to the final place:")
             for lang in languages:
-                log("")
-                log("===== Copying the {lang} site =====".format(lang=lang))
-                source_dir = os.path.join(docs_repo, "public")
-                target_dir_copying = "/antora/output/{lang}.building".format(lang=lang)
-                target_dir_copied = "/antora/output/{lang}.building/{lang}".format(lang=lang)
-                target_dir_final = "/antora/output/{lang}".format(lang=lang)
-                shutil.rmtree(target_dir_copying, ignore_errors=True)
-                subprocess.run(["cp", "-a", source_dir, target_dir_copying])
-                shutil.rmtree(target_dir_final, ignore_errors=True)
-                shutil.move(target_dir_copied, target_dir_final)
-                shutil.rmtree(target_dir_copying, ignore_errors=True)
+                log("  - {}".format(lang))
+                shutil.rmtree(os.path.join(publish_dir, lang), ignore_errors=True)
+                subprocess.run(["mv", os.path.join(copying_dir, "public", lang), "{}/".format(publish_dir)])
+
+            # https://pagure.io/fedora-infrastructure/issue/8964
+            log("Consolidate files with hardlink...")
+            subprocess.run(["hardlink", "-v", "{}/".format(publish_dir)])
+
+            # And finally remove the copying dir
+            log("Removing the copying dir...")
+            shutil.rmtree(copying_dir, ignore_errors=True)
+
+            log("DONE!")
     
 
 

